#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>

int main(int argc, char *argv[])
{
	unsigned short b;
	int rate;
	int fd;

	if (argc < 2)
		return 1;

	fd = open(argv[1], O_RDONLY);
	if (fd == -1) {
		perror("open");
		return 2;
	}

	if (lseek(fd, 0xf002, SEEK_SET) == -1) {
		perror("lseek");
		return 3;
	}

	if (read(fd, &b, sizeof(b)) == -1) {
		perror("read");
		return 4;
	}

	switch (b & 0xf0) {
		case 0x10:
			rate = 32;
			break;
		case 0x20:
			rate = 40;
			break;
		case 0x30:
			rate = 48;
			break;
		case 0x40:
			rate = 56;
			break;
		case 0x50:
			rate = 64;
			break;
		case 0x60:
			rate = 80;
			break;
		case 0x70:
			rate = 96;
			break;
		case 0x80:
			rate = 112;
			break;
		case 0x90:
			rate = 128;
			break;
		case 0xa0:
			rate = 160;
			break;
		case 0xb0:
			rate = 192;
			break;
		case 0xc0:
			rate = 224;
			break;
		case 0xd0:
			rate = 256;
			break;
		case 0xe0:
			rate = 320;
			break;
		default:
			rate = -1;
			break;
	}

	if (rate == -1)
		return 100;

	printf("%d\n", rate);

	close(fd);
	return 0;
}
