#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

int main(int argc, char *argv[])
{
	int mp3_fd, tag_fd;
	struct stat sb;
	char tag[128];

	if (argc < 3)
		return 1;

	mp3_fd = open(argv[1], O_RDONLY);
	if (mp3_fd == -1) {
		perror("open");
		return 2;
	}

	if (fstat(mp3_fd, &sb) == -1) {
		perror("fstat");
		return 3;
	}

	if (lseek(mp3_fd, sb.st_size - 128, SEEK_SET) == -1) {
		perror("lseek");
		return 4;
	}

	if (read(mp3_fd, tag, sizeof(tag)) == -1) {
		perror("read");
		return 5;
	}

	if (strncmp(tag, "TAG", 3)) {
		fprintf(stderr, "No tag\n");
		return 6;
	}

	tag_fd = open(argv[2], O_WRONLY | O_CREAT | O_TRUNC, 0644);
	if (tag_fd == -1) {
		perror("open tag");
		return 7;
	}

	write(tag_fd, tag, sizeof(tag));
	close(mp3_fd);
	close(tag_fd);
	return 0;
}
